/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package maths;

import products.ProductW;

/**
 *
 * @author connie
 */
public class Dose {
    private ProductW    prod;
    private Factors     fact;
    private DPS         dps;
    private boolean     NeedReCalc;
    private float      Calories;
    private float      SlowDose; //медленная доза
    private float      CarbSlowDose;
    private float      CarbFastDose;
    
    public Dose(ProductW newProd, Factors newFs, DPS newDps){
        prod = new ProductW( newProd );
        fact = new Factors(newFs);
        dps = new DPS(newDps);
        NeedReCalc = true;
    }
    public Dose(Dose newDose){
        prod = new ProductW( newDose.prod );
        fact = new Factors( newDose.fact );
        dps = new DPS( newDose.dps );
        NeedReCalc = true;
    }
    
    public Dose(){
        prod = new ProductW();
        fact = new Factors();
        dps = new DPS();
        NeedReCalc = true;
    }
    
    private void calcDoses(){
        float kWH = 4.1f * prod.getAllProt();
        float kFAT = 9.3f * prod.getAllFat();
        float kUG = 4.1f * prod.getAllCarb();
         
        Calories = kWH + kFAT +kUG;

        SlowDose = fact.getK2() * kWH/100f + fact.getK2() * kFAT/100f;
        //    (    WH Doze   )   (   Fat Doze     )
                
        //здесь 1 надо заменить на коэффициент позволяющий учитывать углеводы
        //по количеству
        CarbSlowDose = fact.getK1(Factors.INDIRECT) / fact.getBE(Factors.INDIRECT) *
                    ( prod.getAllCarb() * (100f - (float)prod.getGi()) / 100f );
        CarbFastDose = fact.getK1(Factors.INDIRECT) / fact.getBE(Factors.INDIRECT) *
                ( prod.getAllCarb() *  (float)prod.getGi() / 100f );
        
        NeedReCalc = false;
    }
    
    public void setProduct(ProductW newProduct){
        prod = new ProductW( newProduct );
        NeedReCalc = true;
    }
    
    public void setFactors(Factors newFs){
        fact = new Factors( newFs );
        NeedReCalc = true;
    }
    
    public void setDPS(DPS newDps){
        dps = new DPS(newDps);
        NeedReCalc = true;
    }
    
    public float getSlowDose(){
        if (NeedReCalc) calcDoses();
        return SlowDose;
    }
    
    public float getCarbSlowDose(){
        if (NeedReCalc) calcDoses();
        return CarbSlowDose;
        
    }
    
    public float getCarbFastDose(){
        if (NeedReCalc) calcDoses();
        return CarbFastDose;
    }
    
    public float getCalories(){
        if (NeedReCalc) calcDoses();
        return Calories;
    }
    
    public float getWholeDose(){
        if (NeedReCalc) calcDoses();
        return SlowDose+CarbSlowDose+CarbFastDose+dps.getDPSDose();
    }

    public float getDPSDose(){
        return dps.getDPSDose();
    }

}
