/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package maths;

/**
 *
 * @author connie
 */
import java.util.Collection;
import java.util.Vector;
import java.sql.Time;
import java.util.ArrayList;

public class TimedCoefsSet {//3600000
    public final static long DELTA = 10800000;
    public final static long ONE_HOUR_LONG = 3600000;
    public final static long ZERO = -3*ONE_HOUR_LONG + DELTA;
    public final static long ONE = -2*ONE_HOUR_LONG + DELTA;
    public final static long TWO = -ONE_HOUR_LONG + DELTA;
    public final static long TREE = 0 + DELTA;
    public final static long FOUR = ONE_HOUR_LONG + DELTA;
    public final static long FIVE = ONE_HOUR_LONG*2 + DELTA;
    public final static long SIX = ONE_HOUR_LONG*3 + DELTA;
    public final static long SEVEN = ONE_HOUR_LONG*4 + DELTA;
    public final static long EIGHT = ONE_HOUR_LONG*5 + DELTA;
    public final static long NINE = ONE_HOUR_LONG*6 + DELTA;
    public final static long TEN = ONE_HOUR_LONG*7 + DELTA;
    public final static long ELEVEN = ONE_HOUR_LONG*8 + DELTA;
    public final static long TWELVE = ONE_HOUR_LONG*9 + DELTA;
    public final static long ONE_PM = ONE_HOUR_LONG*10 + DELTA;
    public final static long TWO_PM = ONE_HOUR_LONG*11 + DELTA;
    public final static long TREE_PM = ONE_HOUR_LONG*12 + DELTA;
    public final static long FOUR_PM = ONE_HOUR_LONG*13 + DELTA;
    public final static long FIVE_PM = ONE_HOUR_LONG*14 + DELTA;
    public final static long SIX_PM = ONE_HOUR_LONG*15 + DELTA;
    public final static long SEVEN_PM = ONE_HOUR_LONG*16 + DELTA;
    public final static long EIGHT_PM = ONE_HOUR_LONG*17 + DELTA;
    public final static long NINE_PM = ONE_HOUR_LONG*18 + DELTA;
    public final static long TEN_PM = ONE_HOUR_LONG*19 + DELTA;
    public final static long ELEVEN_PM = ONE_HOUR_LONG*20 + DELTA;
   

    private long [] hours = {
        ZERO,ONE,TWO,TREE,FOUR,FIVE,SIX,SEVEN,EIGHT,NINE,TEN,
        ELEVEN,TWELVE,ONE_PM,TWO_PM,TREE_PM,FOUR_PM,FIVE_PM,SIX_PM,SEVEN_PM,
        EIGHT_PM,NINE_PM,TEN_PM,ELEVEN_PM};
    


    private Vector<CoefsSet>        cfs;
    
    public TimedCoefsSet(Collection<CoefsSet> col){
        cfs = new Vector(col);
    }

    public Collection<CoefsSet> getTimedCoefs(){
        Collection<CoefsSet> result=new ArrayList();
        if (cfs.size()==0) return null;
        for (int i=0;i<24;i++){
            CoefsSet lo = findLo(new Time(hours[i]-DELTA));
            CoefsSet hi = findHi(new Time(hours[i]-DELTA));
            long line = hi.getTime().getTime() - lo.getTime().getTime();
            if (line==0){ result.add(new CoefsSet(0,
                    lo.getK1(),lo.getK2(),lo.getK3(),new Time(hours[i]-DELTA),i,
                    CoefsSet.TIME));
            }
            else{
                if (line<0) line += hours[23];
                long increase = hours[i] - (lo.getTime().getTime()+DELTA);
                if (increase<0) increase += hours[23];
                float newk1 = (hi.getK1() - lo.getK1()) * increase / line + lo.getK1();
                float newk2 = (hi.getK2() - lo.getK2()) * increase / line + lo.getK2();
                float newk3 = (hi.getK3() - lo.getK3()) * increase / line + lo.getK3();
                result.add(new CoefsSet(0,
                    newk1,newk2,newk3,new Time(hours[i]-DELTA),i,
                    CoefsSet.TIME) );
            }
        }
        Vector<CoefsSet> arr = new Vector(result);
        Collection<CoefsSet> res = new ArrayList();
        for (int i=6;i<24;i++){
            res.add(arr.get(i));
        }
        for (int i=0;i<6;i++){
            res.add(arr.get(i));
        }

        /*for (CoefsSet item:res){
            System.out.println(item);
        }*/
        return res;
    }

    private CoefsSet findLo(Time time){
        CoefsSet res=null;
        for (int i=cfs.size(); i>0; i--){
            if (cfs.get(i-1).getTime().getTime()<=time.getTime()){
                res = cfs.get(i-1);
                break;
            }
        }
        if (res==null) res = cfs.lastElement();
        return res;
    }

    private CoefsSet findHi(Time time){
        CoefsSet res=null;
        for (int i=0;i<cfs.size();i++){
            if (cfs.get(i).getTime().getTime()>time.getTime()){
                res = cfs.get(i);
                break;
            }
        }
        if (res==null) res = cfs.firstElement();
        return res;
    }
}

