/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package tablemodels;

/**
 *
 * @author connie
 */

import java.util.Vector;
import javax.swing.table.AbstractTableModel;

import products.ProdGroup;
import manager.GroupManager;
import lookout.settings.ProgramSettings;

public class GroupTableModel extends AbstractTableModel {
 private Vector groups;
 private ProgramSettings settings;
 private GroupManager mgr;

  // Модель при создании получает список студентов
  public GroupTableModel(GroupManager mgr){
      this.mgr = mgr;
      settings = ProgramSettings.getInstance();
      groups = new Vector(mgr.getGroups(settings.getIn().useUsageGroup()));
      
  }
  
  public void updateGroup(ProdGroup gr){
      groups = new Vector(mgr.updateGroup(gr,settings.getIn().useUsageGroup()));
      //fireTableRowsUpdated(0,groups.size()-1);
      fireTableDataChanged();
  }
  
  public void addGroup(ProdGroup gr){
      if ( (groups.size()>0)&&(gr.getSortInd()==0) ){
          
          gr.setSortInd(   ((ProdGroup) groups.get(groups.size()-1)).getSortInd()+1
                  );
      }
      groups = new Vector(mgr.addGroup(gr,settings.getIn().useUsageGroup()));
      //fireTableRowsUpdated(0,groups.size()-1);
      fireTableDataChanged();
  }

  public void deleteGroup(ProdGroup gr){
      if (groups.size()>0){
          int row=-1;
          for(int i=0;i<groups.size();i++){
              if ( ((ProdGroup)groups.get(i)).getId()==gr.getId() ){
                  row = i;
                  break;
              }
          }

          groups = new Vector(mgr.deleteGroup(gr,settings.getIn().useUsageGroup()));
          if (row>=0) {
              this.fireTableRowsDeleted(row, row);
          }
          this.fireTableDataChanged();
      }
      
  }

  // Количество строк равно числу записей
  @Override
  public int getRowCount()
  {

    if (groups != null) {
      return groups.size();
    }
    return 0;
  }
  
  // Количество столбцов - 4. Фамилия, Имя, Отчество, Дата рождения
  @Override
  public int getColumnCount()
  {
    return 1;
  }

  // Вернем наименование колонки
  @Override 
  public String getColumnName(int column)
  {
     return "Наименование";
  }

  // Возвращаем данные для определенной строки и столбца
  @Override
  public Object getValueAt(int rowIndex, int columnIndex)

  {
    if ( (groups != null)){//&&(rowIndex<groups.size()) ) {
      // Получаем из вектора студента
      ProdGroup gr = (ProdGroup) groups.get(rowIndex);

      // В зависимости от колонки возвращаем имя, фамилия и т.д.
      switch (columnIndex) {
      case 0:
        return gr.getName();
      }
    }// else if (rowIndex>=groups.size()) System.out.println("Row="+rowIndex);
    return null;

  }

      
  public ProdGroup getGroup(int rowIndex)
  {
    if(groups!=null) {
      if(rowIndex<groups.size() && rowIndex>=0) {
        return (ProdGroup)groups.get(rowIndex);
      }
    }
    return null;
  }   
  public void reloadGroups(){
      groups = new Vector(mgr.getGroups(settings.getIn().useUsageGroup()));
      if (groups.size()>0)
          fireTableDataChanged();
  }    
  public int findRow(int id){
      int row = -1;
      if (groups.size()>0){
         Object [] pr = groups.toArray();
         for (int i=0;i<groups.size();i++){
             if ( ((ProdGroup)pr[i]).getId()==id ){
                 row = i;
                 break;
             }
         }
      }
      return row;
  }

}
